
script.on_event(defines.events.on_player_created, function(event)
    player = game.players[event.player_index]
	
	player.insert{name="iron-plate", count=42}  
	player.insert{name="stone", count=50}		
	player.insert{name="coal", count=50}		
	player.insert{name="raw-wood", count=50}
	player.insert{name="iron-axe", count=1}
	
	player.insert{name="copper-plate", count=50}
end)

script.on_event(defines.events.on_built_entity, function(event)
	--
	add_acc(event.created_entity)
	--

	if	event.created_entity ~= nil and event.created_entity.name == "siege_turret_1" or event.created_entity.name == "siege_turret_2" or event.created_entity.name == "siege_turret_3" then
		local player = game.players[event.player_index]
		local turret2 = event.created_entity
		if 		player.get_item_count("turret_ammo_box") >= 5 then
				player.remove_item{name="turret_ammo_box", count=5}
				turret2.insert{name="turret_ammo_box", count=5}
		end

	end 
end)


script.on_event(defines.events.on_tick, function(event)
	for p_id, pl in pairs(game.players) do
	if (game.tick % 120) == 0 and game.players[p_id].driving and game.players[p_id].vehicle.type == "car" then
	if  game.players[p_id].vehicle.name == "t55" or game.players[p_id].vehicle.name == "devastator" then
	if #game.players[p_id].vehicle.grid.equipment > 0 and checkbat(game.players[p_id].vehicle.grid.equipment) ~= 0then
	
	local d = game.players[p_id].vehicle
	local q = d.grid.equipment
			for z = 1, #q do
			if q[z].type == "battery-equipment" then
			if 5000000 <= (q[z].max_energy - q[z].energy) and d.get_item_count("fuel_cell_3") > 0  then
			d.remove_item{name="fuel_cell_3", count=1}
			q[z].energy = q[z].energy + 5000000
			elseif 2500000 <= (q[z].max_energy - q[z].energy) and d.get_item_count("fuel_cell_2") > 0  then
			d.remove_item{name="fuel_cell_2", count=1}
			q[z].energy = q[z].energy + 2500000
			elseif 500000 <= (q[z].max_energy - q[z].energy) and d.get_item_count("fuel_cell_1") > 0  then
			d.remove_item{name="fuel_cell_1", count=1}
			q[z].energy = q[z].energy + 500000	
			end
			end
			end
	end
	end
	end
	end
	
	if (game.tick % 15) == 0 then
		if global.ACC then
		equalize()
		end
	end

end)

function checkbat(z)
	if #z == 0 then
	return 0
	end
	
	for t=1, #z do
	if z[t].type == "battery-equipment" then
	return 1
	end
	end
	
	return 0
end

---ACCUMULATOR---
script.on_init(function()
   global.ACC = {}

end)


script.on_event(defines.events.on_robot_built_entity, function(event)
   add_acc(event.created_entity)
end)
script.on_event(defines.events.on_pre_player_mined_item, function(event) 
   del_acc(event.entity)
end)
script.on_event(defines.events.on_robot_pre_mined, function(event)
   del_acc(event.entity)
end)
script.on_event(defines.events.on_entity_died, function(event)
   del_acc(event.entity)
end)

function add_acc(entity)
	if entity.name == "shared_accumulator" then
		if global.ACC == nil then
		global.ACC = {}
		end
	table.insert(global.ACC, entity)
	end
end

function del_acc(entity)
   if entity.name == "shared_accumulator" then
	  local finish_him_i
	
      for i,e in pairs(global.ACC) do
         if e == entity and entity.position.x == e.position.x and entity.position.y == e.position.y then
            finish_him_i = i
            break
         end
      end
      table.remove(global.ACC, finish_him_i)
	  
   end
end

function equalize()

local mid = 0 					--average value of charge
local summ = 0					--total charge
local low_e = {}				--table of <mid accumulators
local top_e = {}				--table of >mid accumulators
local needed_el = 0				--how many energy we need to give
local can_give_el = 0			--how many energy we can give
local collected = 0				--energy collector
local need_to_collect = 0		--in case when we can give more than we need, how many energy we collect from each top_e accumulator
local give = 0					--how many we give to each low_e accumulator
	--summ of all accumulator energy
	for i,e in pairs(global.ACC) do
	if e and e.valid then
	summ = summ + e.energy
	end
	end
	-- average value of energy
	if #global.ACC > 0 then
	mid = summ / #global.ACC
	end
	-- find who need energy and who can can give
	for i,e in pairs(global.ACC) do
		if e and e.valid then
			if e.energy < mid then table.insert(low_e, e)
			elseif e.energy >= mid then table.insert(top_e, e)
			end
		end
	end
	needed_el = #low_e*75000
	can_give_el = #top_e*75000
	--if we can give less than we need
	if (can_give_el-needed_el) <= 0 and #top_e > 0 and #low_e > 0   then
		for i,e in pairs(top_e) do
			if (e.energy-mid) >= 75000 then
			e.energy = e.energy - 75000
			collected = collected +75000
			else
			collected = collected + (e.energy-mid)
			e.energy = e.energy - (e.energy-mid)
			end
		end
	give = collected / #low_e
		for i,e in pairs (low_e) do
		e.energy = e.energy + give
		end
	--if we can give more than we need
	elseif (can_give_el-needed_el) > 0 and #top_e > 0 and #low_e > 0   then
	need_to_collect = needed_el/#top_e
		for i,e in pairs(top_e) do
			if (e.energy-need_to_collect) > 0 then
			e.energy = e.energy - need_to_collect
			collected = collected + need_to_collect
			else
			collected = collected + e.energy
			e.energy = 0
			end
		end
		give = collected / #low_e
		for i,e in pairs (low_e) do
		e.energy = e.energy + give
		end
	end
end






-- /c game.player.force.reset_recipes()
-- /c game.player.force.reset_technologies()