 data:extend({ 

-------- T 55 --------
 
 {
    type = "car",
    name = "t55",
    icon = "__FMRx__/graphics/t55/t55_ico.png",
	icon_size = 32,
    flags = {"pushable", "placeable-neutral", "player-creation", "placeable-off-grid"},
    minable = {mining_time = 1, result = "t55"},
    max_health = 3000,
    corpse = "medium-remnants",
    dying_explosion = "medium-explosion",
    energy_per_hit_point = 0.5,
    resistances =
    {
      {
        type = "fire",
        decrease = 10,
        percent = 40
      },
      {
        type = "physical",
        decrease = 10,
        percent = 40
      },
      {
        type = "impact",
        decrease = 50,
        percent = 50
      },
      {
        type = "explosion",
        decrease = 20,
        percent = 50
      },
      {
        type = "acid",
        decrease = 10,
        percent = 20
      }
    },
    collision_box = {{-1.55, -1.95}, {1.55, 1.95}},
    selection_box = {{-1.55, -1.95}, {1.55, 1.95}},
    effectivity = 0.7,
    braking_power = "800kW",
    burner =
    {
	  fuel_category = "f_tank",
      effectivity = 0.75,
      fuel_inventory_size = 3,
      smoke =
      {
        {
          name = "tank-smoke",
          deviation = {0.25, 0.25},
          frequency = 50,
          position = {0, 1.5},
          starting_frame = 0,
          starting_frame_deviation = 60
        }
      }
    },
    consumption = "1200kW",
    terrain_friction_modifier = 0.2,
    friction = 0.002,
    light =
    {
      {
        type = "oriented",
        minimum_darkness = 0.3,
        picture =
        {
          filename = "__core__/graphics/light-cone.png",
          priority = "medium",
          scale = 2,
          width = 200,
          height = 200
        },
        shift = {-0.6, -14},
        size = 2,
        intensity = 0.6
      },
      {
        type = "oriented",
        minimum_darkness = 0.3,
        picture =
        {
          filename = "__core__/graphics/light-cone.png",
          priority = "medium",
          scale = 2,
          width = 200,
          height = 200
        },
        shift = {0.6, -14},
        size = 2,
        intensity = 0.6
      }
    },
    animation =
    {
      layers =
      {
        {
          width = 224,
          height = 224,
          frame_count = 2,
          direction_count = 64,
          shift = {0.0, 0.0},
          animation_speed = 8,
          max_advance = 1,
          stripes =
          {
            {
             filename = "__FMRx__/graphics/t55/t55_1.png",
             width_in_frames = 2,
             height_in_frames = 8,
            },
            {
             filename = "__FMRx__/graphics/t55/t55_2.png",
             width_in_frames = 2,
             height_in_frames = 8,
            },
            {
             filename = "__FMRx__/graphics/t55/t55_3.png",
             width_in_frames = 2,
             height_in_frames = 8,
            },
            {
             filename = "__FMRx__/graphics/t55/t55_4.png",
             width_in_frames = 2,
             height_in_frames = 8,
            },
			{
             filename = "__FMRx__/graphics/t55/t55_5.png",
             width_in_frames = 2,
             height_in_frames = 8,
            },
            {
             filename = "__FMRx__/graphics/t55/t55_6.png",
             width_in_frames = 2,
             height_in_frames = 8,
            },
            {
             filename = "__FMRx__/graphics/t55/t55_7.png",
             width_in_frames = 2,
             height_in_frames = 8,
            },
            {
             filename = "__FMRx__/graphics/t55/t55_8.png",
             width_in_frames = 2,
             height_in_frames = 8,
            }
          }
        },
		
        {
          width = 224,
          height = 224,
          frame_count = 2,
          draw_as_shadow = true,
          direction_count = 64,
          shift = {0, 0},
          max_advance = 1,
          stripes = util.multiplystripes(2, 
          {
           {
            filename = "__FMRx__/graphics/t55/t55_shadow_1.png",
            width_in_frames = 1,
            height_in_frames = 8,
           },
           {
            filename = "__FMRx__/graphics/t55/t55_shadow_2.png",
            width_in_frames = 1,
            height_in_frames = 8,
           },
           {
            filename = "__FMRx__/graphics/t55/t55_shadow_3.png",
            width_in_frames = 1,
            height_in_frames = 8,
           },
           {
            filename = "__FMRx__/graphics/t55/t55_shadow_4.png",
            width_in_frames = 1,
            height_in_frames = 8,
           },
           {
            filename = "__FMRx__/graphics/t55/t55_shadow_5.png",
            width_in_frames = 1,
            height_in_frames = 8,
           },
           {
            filename = "__FMRx__/graphics/t55/t55_shadow_6.png",
            width_in_frames = 1,
            height_in_frames = 8,
           },
           {
            filename = "__FMRx__/graphics/t55/t55_shadow_7.png",
            width_in_frames = 1,
            height_in_frames = 8,
           },
           {
            filename = "__FMRx__/graphics/t55/t55_shadow_8.png",
            width_in_frames = 1,
            height_in_frames = 8,
           }		   
          } )
        }
      }
    },
    turret_animation =
    {
      layers =
      {
        {
          --filename = "__FMRx__/graphics/t55/t55_t.png",
         -- line_length = 8,
          width = 352,
          height = 352,
          frame_count = 1,
          direction_count = 64,
          shift = {0.04, -0.5},
          animation_speed = 8,
		  max_advance = 1,
		  stripes =
          {
            {
             filename = "__FMRx__/graphics/t55/t55_t_1.png",
             width_in_frames = 4,
             height_in_frames = 4,
            },
            {
             filename = "__FMRx__/graphics/t55/t55_t_2.png",
             width_in_frames = 4,
             height_in_frames = 4,
            },
            {
             filename = "__FMRx__/graphics/t55/t55_t_3.png",
             width_in_frames = 4,
             height_in_frames = 4,
            },
            {
             filename = "__FMRx__/graphics/t55/t55_t_4.png",
             width_in_frames = 4,
             height_in_frames = 4,
            }
          }
        },
        {
          width = 352,
          height = 352,
          frame_count = 1,
          draw_as_shadow = true,
          direction_count = 64,
          shift = {0.54, -0.5},
          max_advance = 1,
          stripes =
		  {
           {
            filename = "__FMRx__/graphics/t55/t55_tower_shadow_1.png",
            width_in_frames = 4,
            height_in_frames = 4,
           },
           {
            filename = "__FMRx__/graphics/t55/t55_tower_shadow_2.png",
            width_in_frames = 4,
            height_in_frames = 4,
           },
           {
            filename = "__FMRx__/graphics/t55/t55_tower_shadow_3.png",
            width_in_frames = 4,
            height_in_frames = 4,
           },
           {
            filename = "__FMRx__/graphics/t55/t55_tower_shadow_4.png",
            width_in_frames = 4,
            height_in_frames = 4,
           }
          }
        }	
      }
    },
    turret_rotation_speed = 0.35 / 60,
    turret_return_timeout = 120,
    stop_trigger_speed = 0.2,
    sound_no_fuel =
    {
      {
        filename = "__base__/sound/fight/tank-no-fuel-1.ogg",
        volume = 0.6
      },
    },
    stop_trigger =
    {
      {
        type = "play-sound",
        sound =
        {
          {
            filename = "__base__/sound/car-breaks.ogg",
            volume = 0.6
          },
        }
      },
    },
    sound_minimum_speed = 0.15;
    vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },
    working_sound =
    {
      sound =
      {
        filename = "__base__/sound/fight/tank-engine.ogg",
        volume = 0.6
      },
      activate_sound =
      {
        filename = "__base__/sound/fight/tank-engine-start.ogg",
        volume = 0.6
      },
      deactivate_sound =
      {
        filename = "__base__/sound/fight/tank-engine-stop.ogg",
        volume = 0.6
      },
      match_speed_to_activity = true,
    },
    open_sound = { filename = "__base__/sound/car-door-open.ogg", volume=0.7 },
    close_sound = { filename = "__base__/sound/car-door-close.ogg", volume = 0.7 },
    rotation_speed = 0.0042,
    tank_driving = true,
    weight = 17000,
    inventory_size = 80,
	equipment_grid = "t55",
    guns = { "t55_cannon" },
  },
  {
    type = "gun",
    name = "t55_cannon",
    icon = "__FMRx__/graphics/t55/t55_cannon.png",
	icon_size = 32,
    flags = {"goes-to-main-inventory", "hidden"},
    subgroup = "gun",
    order = "z[tank]-a[cannon]",
    attack_parameters =
    {
      type = "projectile",
      ammo_category = "t55_ammo",
      cooldown = 90,
      movement_slow_down_factor = 0,
      projectile_creation_distance = 5.40,
      projectile_center = {0.04, 0.75},
      range = 30,
      sound =
      {
        {
          filename = "__base__/sound/fight/tank-cannon.ogg",
          volume = 1.0
        }
      },
    },
    stack_size = 5
  },

  {
    type = "equipment-grid",
    name = "t55",
    width = 8,
    height =4,
    equipment_categories = {"a-tank"}
  },

---------------- DEVASTATOR ----------------
{
    type = "car",
    name = "devastator",
    icon = "__FMRx__/graphics/devastator/dev_ico.png",
	icon_size = 32,
    flags = {"pushable", "placeable-neutral", "player-creation", "placeable-off-grid"},
    minable = {mining_time = 1, result = "devastator"},
    max_health = 1800,
    corpse = "medium-remnants",
    dying_explosion = "medium-explosion",
    energy_per_hit_point = 0.5,
    resistances =
    {
      {
        type = "fire",
        decrease = 10,
        percent = 40
      },
      {
        type = "physical",
        decrease = 10,
        percent = 40
      },
      {
        type = "impact",
        decrease = 35,
        percent = 50
      },
      {
        type = "explosion",
        decrease = 30,
        percent = 30
      },
      {
        type = "acid",
        decrease = 13,
        percent = 20
      }
    },
    collision_box = {{-1.55, -1.95}, {1.55, 1.95}},
    selection_box = {{-1.55, -1.95}, {1.55, 1.95}},
    effectivity = 0.7,
    braking_power = "1000kW",
    burner =
    {
	  fuel_category = "f_tank",
      effectivity = 0.8,
      fuel_inventory_size = 2,
      smoke =
      {
        {
          name = "tank-smoke",
          deviation = {0.25, 0.25},
          frequency = 50,
          position = {0, 1.5},
          starting_frame = 0,
          starting_frame_deviation = 60
        }
      }
    },
    consumption = "800kW",
    terrain_friction_modifier = 0.2,
    friction = 0.0015,
    light =
    {
      {
        type = "oriented",
        minimum_darkness = 0.3,
        picture =
        {
          filename = "__core__/graphics/light-cone.png",
          priority = "medium",
          scale = 2,
          width = 200,
          height = 200
        },
        shift = {-0.6, -14},
        size = 2,
        intensity = 0.6
      },
      {
        type = "oriented",
        minimum_darkness = 0.3,
        picture =
        {
          filename = "__core__/graphics/light-cone.png",
          priority = "medium",
          scale = 2,
          width = 200,
          height = 200
        },
        shift = {0.6, -14},
        size = 2,
        intensity = 0.6
      }
    },
    animation =
    {
      layers =
      {
        {
          width = 224,
          height = 224,
          frame_count = 3,
          direction_count = 64,
          shift = {0.0, 0.0},
          animation_speed = 5,
          max_advance = 1,
          stripes =
          {
            {
             filename = "__FMRx__/graphics/devastator/dev_1.png",
             width_in_frames = 3,
             height_in_frames = 8,
            },
            {
             filename = "__FMRx__/graphics/devastator/dev_2.png",
             width_in_frames = 3,
             height_in_frames = 8,
            },
            {
             filename = "__FMRx__/graphics/devastator/dev_3.png",
             width_in_frames = 3,
             height_in_frames = 8,
            },
            {
             filename = "__FMRx__/graphics/devastator/dev_4.png",
             width_in_frames = 3,
             height_in_frames = 8,
            },
			{
             filename = "__FMRx__/graphics/devastator/dev_5.png",
             width_in_frames = 3,
             height_in_frames = 8,
            },
            {
             filename = "__FMRx__/graphics/devastator/dev_6.png",
             width_in_frames = 3,
             height_in_frames = 8,
            },
            {
             filename = "__FMRx__/graphics/devastator/dev_7.png",
             width_in_frames = 3,
             height_in_frames = 8,
            },
            {
             filename = "__FMRx__/graphics/devastator/dev_8.png",
             width_in_frames = 3,
             height_in_frames = 8,
            }
          }
        },
		
        {
          width = 224,
          height = 224,
          frame_count = 3,
          draw_as_shadow = true,
          direction_count = 64,
          shift = {0.5, 0},
          max_advance = 1,
          stripes = util.multiplystripes(3, 
          {
           {
            filename = "__FMRx__/graphics/devastator/dev_shadow_1.png",
            width_in_frames = 1,
            height_in_frames = 8,
           },
           {
            filename = "__FMRx__/graphics/devastator/dev_shadow_2.png",
            width_in_frames = 1,
            height_in_frames = 8,
           },
           {
            filename = "__FMRx__/graphics/devastator/dev_shadow_3.png",
            width_in_frames = 1,
            height_in_frames = 8,
           },
           {
            filename = "__FMRx__/graphics/devastator/dev_shadow_4.png",
            width_in_frames = 1,
            height_in_frames = 8,
           },
           {
            filename = "__FMRx__/graphics/devastator/dev_shadow_5.png",
            width_in_frames = 1,
            height_in_frames = 8,
           },
           {
            filename = "__FMRx__/graphics/devastator/dev_shadow_6.png",
            width_in_frames = 1,
            height_in_frames = 8,
           },
           {
            filename = "__FMRx__/graphics/devastator/dev_shadow_7.png",
            width_in_frames = 1,
            height_in_frames = 8,
           },
           {
            filename = "__FMRx__/graphics/devastator/dev_shadow_8.png",
            width_in_frames = 1,
            height_in_frames = 8,
           }		   
          } )
        }
      }
    },
    turret_animation =
    {
      layers =
      {
        {
		  filename = "__FMRx__/graphics/devastator/dev_t.png",
		  line_length = 8,
          width = 160,
          height = 160,
          frame_count = 1,
          direction_count = 64,
          shift = {-0.05, -0.5},
          animation_speed = 8,
		  max_advance = 1
        },
        {
		  filename = "__FMRx__/graphics/devastator/dev_t_shadow.png",
		  line_length = 8,
          width = 160,
          height = 160,
          frame_count = 1,
          draw_as_shadow = true,		  
          direction_count = 64,
          shift = {-0.05, -0.5},
          animation_speed = 8,
		  max_advance = 1
        },	
      }
    },
    turret_rotation_speed = 0.4 / 60,
    turret_return_timeout = 120,
    stop_trigger_speed = 0.2,
    sound_no_fuel =
    {
      {
        filename = "__base__/sound/fight/tank-no-fuel-1.ogg",
        volume = 0.6
      },
    },
    stop_trigger =
    {
      {
        type = "play-sound",
        sound =
        {
          {
            filename = "__base__/sound/car-breaks.ogg",
            volume = 0.6
          },
        }
      },
    },
    sound_minimum_speed = 0.15;
    vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },
    working_sound =
    {
      sound =
      {
        filename = "__base__/sound/fight/tank-engine.ogg",
        volume = 0.6
      },
      activate_sound =
      {
        filename = "__base__/sound/fight/tank-engine-start.ogg",
        volume = 0.6
      },
      deactivate_sound =
      {
        filename = "__base__/sound/fight/tank-engine-stop.ogg",
        volume = 0.6
      },
      match_speed_to_activity = true,
    },
    open_sound = { filename = "__base__/sound/car-door-open.ogg", volume=0.7 },
    close_sound = { filename = "__base__/sound/car-door-close.ogg", volume = 0.7 },
    rotation_speed = 0.0042,
    tank_driving = true,
    weight = 8000,
	equipment_grid = "dev",
    inventory_size = 40,
    guns = { "dev_cannon" },
  },
  
  {
    type = "gun",
    name = "dev_cannon",
    icon = "__FMRx__/graphics/devastator/dev_cannon.png",
	icon_size = 32,
    flags = {"goes-to-main-inventory"},
    subgroup = "gun",
    order = "a[basic-clips]-b[tank-machine-gun]",
    attack_parameters =
    {
      type = "projectile",
      ammo_category = "dev_ammo",
      cooldown = 5,
      movement_slow_down_factor = 0,
      damage_modifier = 1,
	  projectile_center = {-0.05, 0.05},
      projectile_creation_distance = 1.85,
      range = 40,
      sound =
      {
        {
          filename = "__base__/sound/pump-shotgun.ogg",
          volume = 0.5
        }
      }
    },
    stack_size = 1
  },

  {
    type = "equipment-grid",
    name = "dev",
    width = 8,
    height = 4,
    equipment_categories = {"a-tank"}
  },

  
})