function recipe_nofluid_category(r_name, r_enabled, r_order, r_energy, r_ingridient, r_result, r_category) 
	local r_enabled_name = "false"
	if r_enabled == 1 then
		r_enabled_name = "true"
	end
   local result =
   {
    type = "recipe",
    name = r_name,
	enabled = r_enabled_name,
	order = r_order,
	category = r_category,
    energy_required = r_energy,
    ingredients = r_ingridient,
    results = r_result
   }
return result
end 

function recipe_nofluid_category_ico(r_name, r_enabled, r_order, r_energy, r_ingridient, r_result, r_category, r_ico, r_subgroup) 
	local r_enabled_name = "false"
	if r_enabled == 1 then
		r_enabled_name = "true"
	end
   local result =
   {
    type = "recipe",
    name = r_name,
	enabled = r_enabled_name,
	order = r_order,
	category = r_category,
    energy_required = r_energy,
	icon = "__FMRx__/graphics/" .. r_ico,
	icon_size = 32,	
    ingredients = r_ingridient,
	subgroup = r_subgroup,
    results = r_result
   }
return result
end 

function recipe_fluid(r_name, r_enabled, r_order, r_energy, r_ingridient, r_result, r_category,r_ico, r_subgroup) 
	local r_enabled_name = "false"
	if r_enabled == 1 then
		r_enabled_name = "true"
	end
   local result =
   {
    type = "recipe",
    name = r_name,
	enabled = r_enabled_name,
	energy_required = r_energy,
	order = r_order,
	category = r_category,	
    ingredients = r_ingridient,
	subgroup = r_subgroup,
    results= r_result,
	icon = "__FMRx__/graphics/" .. r_ico,
	icon_size = 32,
	main_product= ""
   }
return result
end  



data:extend({
-- ore --
recipe_nofluid_category_ico("veridium_dust", 0, "s-a-b", 5, {{"raw_veridium", 2},{"roll", 1}}, {{type="item", name="veridium_dust", amount=3},{type="item", name="broken_roll", amount=1}}, "grinder","veridium_dust.png", "a_ore"),
recipe_nofluid_category("roll", 0, "s-a-c", 0.5, {{"raw_veridium", 6},{"iron-plate", 4}}, {{type="item", name="roll", amount=2}}, "crafting"),
recipe_nofluid_category("roll_repair", 0, "s-a-d", 1, {{"broken_roll", 5},{"veridium_dust", 1}}, {{type="item", name="roll", amount=5}}, "crafting"),
recipe_nofluid_category("veridium", 0, "s-a-e", 4, {{"veridium_dust", 2}}, {{type="item", name="veridium", amount=1}}, "smelting"),
recipe_nofluid_category("veridium_steel_plate", 0, "s-a-f", 30, {{"veridium", 12}}, {{type="item", name="veridium_steel_plate", amount=2}}, "smelting"),
recipe_nofluid_category("coal_pack", 1, "s-a-g", 1, {{"coal", 8}}, {{type="item", name="coal_pack", amount=1}}, "crafting"),
recipe_nofluid_category("iron_ore_pack", 1, "s-a-h", 1, {{"iron-ore", 8}}, {{type="item", name="iron_ore_pack", amount=1}}, "crafting"),
recipe_nofluid_category("copper_ore_pack", 1, "s-a-i", 1, {{"copper-ore", 8}}, {{type="item", name="copper_ore_pack", amount=1}}, "crafting"),
recipe_fluid("pure_veridium", 0, "s-a-j", 3, {{type="item", name="raw_veridium", amount=3},{type="fluid", name="water", amount=40}},
{{type="item", name="pure_veridium", amount=1}},"chemistry","pure_veridium.png","a_ore"),
recipe_fluid("verkaline", 0, "s-a-k", 2, {{type="item", name="pure_veridium", amount=4},{type="fluid", name="water", amount=40}},
{{type="fluid", name="verkaline", amount=40}},"chemistry","liquid/verkaline.png","a_ore"),
recipe_fluid("veridium_separation", 0, "s-a-l", 5, {{type="fluid", name="verkaline", amount=50}},
{{type="fluid", name="essence", amount=15},{type="fluid", name="kitanium", amount=15},{type="fluid", name="waste", amount=20}},"oil-processing","liquid/veridium_separation.png","a_ore"),
recipe_fluid("waste_recycle", 0, "s-a-ll", 20, {{type="fluid", name="waste", amount=250}},
{{type="fluid", name="light-oil", amount=35},{type="fluid", name="heavy-oil", amount=50}},"oil-processing","liquid/waste_recycle.png","a_ore"),
recipe_fluid("prepared_water", 0, "s-a-o", 1, {{type="fluid", name="kitanium", amount=10},{type="fluid", name="water", amount=40}},
{{type="fluid", name="prepared_water", amount=50}},"chemistry","liquid/prepared_water.png","a_ore"),
recipe_fluid("enriched_fuel_1", 0, "s-a-p", 4, {{type="fluid", name="essence", amount=40},{type="item", name="solid-fuel", amount=16}},
{{type="item", name="enriched_fuel", amount=3}},"chemistry","enriched_fuel.png","a_ore"),
recipe_fluid("enriched_fuel_2", 0, "s-a-q", 4, {{type="fluid", name="kitanium", amount=25},{type="item", name="solid-fuel", amount=16}},
{{type="item", name="enriched_fuel", amount=3}},"chemistry","enriched_fuel.png","a_ore"),
recipe_fluid("diesel_fuel", 0, "s-a-r", 1, {{type="fluid", name="light-oil", amount=25},{type="fluid", name="heavy-oil", amount=45}},
{{type="item", name="diesel_fuel", amount=1}},"chemistry","diesel_fuel.png","a_ore"),

-- pack --
recipe_nofluid_category_ico("iron_plate2", 1, "s-b-a", 25, {{"iron_ore_pack", 1}}, {{type="item", name="iron-plate", amount=8}}, "smelting", "iron_plate2.png","a_pack"),
recipe_nofluid_category_ico("copper_plate2", 1, "s-b-b", 25, {{"copper_ore_pack", 1}}, {{type="item", name="copper-plate", amount=8}}, "smelting", "copper_plate2.png","a_pack"),
recipe_nofluid_category("autogen_1", 0, "s-b-c", 2, {{"solid-fuel", 5},{"steel-plate", 2},{"veridium", 2}}, {{type="item", name="autogen_1", amount=1}}, "crafting"),
recipe_nofluid_category("autogen_2", 0, "s-b-d", 2, {{"solid-fuel", 15},{"autogen_1", 2},{"veridium", 4}}, {{type="item", name="autogen_2", amount=1}}, "crafting"),
recipe_nofluid_category("engine", 0, "s-b-dd", 6, {{"engine-unit", 4},{"veridium_steel_plate", 4},{"iron-gear-wheel", 8}}, {{type="item", name="engine", amount=1}}, "crafting"),
recipe_nofluid_category("wheel", 0, "s-b-e", 1, {{"veridium_steel_plate", 6},{"iron-plate", 6}}, {{type="item", name="wheel", amount=1}}, "crafting"),
recipe_nofluid_category("t55_wheel", 0, "s-b-f", 1, {{"veridium_steel_plate", 10},{"steel-plate", 4}}, {{type="item", name="t55_wheel", amount=1}}, "crafting"),
recipe_nofluid_category("armor_plate_1", 0, "s-b-g", 1, {{"veridium_steel_plate", 8},{"iron-plate", 6},{"veridium", 4}}, {{type="item", name="armor_plate_1", amount=1}}, "crafting"),
recipe_nofluid_category("armor_plate_2", 0, "s-b-h", 1, {{"veridium_steel_plate", 6},{"iron-plate", 4},{"veridium", 6}}, {{type="item", name="armor_plate_2", amount=1}}, "crafting"),
recipe_nofluid_category("plastic_bottle", 0, "s-b-i", 1, {{"plastic-bar", 1}}, {{type="item", name="plastic_bottle", amount=3}}, "crafting"),
recipe_fluid("electrolyte", 0, "s-b-j", 2, {{type="item", name="plastic_bottle", amount=1},{type="fluid", name="prepared_water", amount=40},{type="fluid", name="sulfuric-acid", amount=10}},
{{type="item", name="electrolyte", amount=1}},"chemistry","electrolyte.png","a_pack"),
recipe_nofluid_category("fc_frame", 0, "s-b-k", 1, {{"veridium", 1},{"iron-stick", 1}}, {{type="item", name="fc_frame", amount=1}}, "crafting"),
recipe_fluid("wire", 0, "s-b-l", 0.5, {{type="item", name="copper-cable", amount=3},{type="fluid", name="kitanium", amount=1}},
{{type="item", name="wire", amount=1}},"chemistry","wire.png","a_pack"),
recipe_nofluid_category("round_circuit", 0, "s-b-m", 2, {{"electronic-circuit", 4},{"wire", 2}}, {{type="item", name="round_circuit", amount=1}}, "crafting"),
recipe_nofluid_category("cpu", 0, "s-b-n", 6, {{"round_circuit", 4},{"wire", 12},{"electronic-circuit", 8}}, {{type="item", name="cpu", amount=1}}, "crafting"),
recipe_nofluid_category("quad_circuit", 0, "s-b-o", 4, {{"cpu", 4},{"round_circuit", 8},{"wire", 12}}, {{type="item", name="quad_circuit", amount=1}}, "crafting"),
recipe_fluid("energy_saving_element", 0, "s-b-p", 120, {{type="item", name="pure_veridium", amount=50},{type="fluid", name="essence", amount=500}},
{{type="item", name="energy_saving_element", amount=50}},"crafting-with-fluid","energy_saving_element.png","a_pack"),

--- ore extractor ---
recipe_nofluid_category("ore_extractor_1", 1, "s-c-a", 1, {{"iron-gear-wheel", 10},{"copper-plate", 10},{"veridium", 15},{"stone-brick", 10}}, {{type="item", name="ore_extractor_1", amount=1}},"crafting"),
recipe_nofluid_category("ore_extractor_2", 0, "s-c-b", 1, {{"ore_extractor_1", 1},{"copper-plate", 30},{"veridium", 25},{"engine-unit", 4}}, {{type="item", name="ore_extractor_2", amount=1}},"crafting"),
recipe_nofluid_category("ore_extractor_3", 0, "s-c-c", 1, {{"ore_extractor_2", 1},{"speed-module", 1},{"veridium", 10},{"engine", 2}}, {{type="item", name="ore_extractor_3", amount=1}},"crafting"),
recipe_nofluid_category("electric_ore_extractor_1", 0, "s-c-d", 1, {{"rush_module_1", 1},{ "veridium_steel_plate", 20},{"round_circuit", 10},{"engine", 4}}, {{type="item", name="electric_ore_extractor_1", amount=1}},"crafting"),
recipe_nofluid_category("electric_ore_extractor_2", 0, "s-c-e", 1, {{"electric_ore_extractor_1", 2},{"cpu", 2}}, {{type="item", name="electric_ore_extractor_2", amount=1}},"crafting"),
recipe_nofluid_category("train_chest_h", 0, "s-c-f", 1, {{ "veridium", 24}}, {{type="item", name="train_chest_h", amount=1}},"crafting"),
recipe_nofluid_category("train_chest_v", 0, "s-c-g", 1, {{ "veridium", 24}}, {{type="item", name="train_chest_v", amount=1}},"crafting"),
recipe_nofluid_category("grinder",0, "s-c-h", 1, {{ "iron-plate", 8},{ "iron-gear-wheel", 6},{ "stone", 15}}, {{type="item", name="grinder", amount=1}},"crafting"),
recipe_nofluid_category("shared_accumulator", 0, "s-c-i", 5, {{ "accumulator", 8},{"energy_saving_element", 25},{ "quad_circuit", 4}}, {{type="item", name="shared_accumulator", amount=1}},"crafting"),

-- module --
recipe_nofluid_category("rush_module_1", 0, "s-d-a", 30, {{"round_circuit", 15},{"advanced-circuit", 10},{"speed-module", 3}}, {{type="item", name="rush_module_1", amount=1}},"crafting"),
recipe_nofluid_category("rush_module_2", 0, "s-d-b", 30, {{"cpu", 5},{"processing-unit", 10},{"rush_module_1", 3}}, {{type="item", name="rush_module_2", amount=1}},"crafting"),
recipe_nofluid_category("rush_module_3", 0, "s-d-c", 30, {{"quad_circuit", 5},{"speed-module-3", 1},{"rush_module_2", 1}}, {{type="item", name="rush_module_3", amount=1}},"crafting"),

recipe_nofluid_category("economy_module_1", 0, "s-d-d", 30, {{"round_circuit", 15},{"advanced-circuit", 10},{"effectivity-module", 3}}, {{type="item", name="economy_module_1", amount=1}},"crafting"),
recipe_nofluid_category("economy_module_2", 0, "s-d-e", 30, {{"cpu", 5},{"processing-unit", 10},{"economy_module_1", 3}}, {{type="item", name="economy_module_2", amount=1}},"crafting"),
recipe_nofluid_category("economy_module_3", 0, "s-d-f", 30, {{"quad_circuit", 5},{"speed-module-3", 1},{"economy_module_2", 1}}, {{type="item", name="economy_module_3", amount=1}},"crafting"),

recipe_nofluid_category("multiply_module_1", 0, "s-d-g", 30, {{"round_circuit", 15},{"advanced-circuit", 10},{"productivity-module", 3}}, {{type="item", name="multiply_module_1", amount=1}},"crafting"),
recipe_nofluid_category("multiply_module_2", 0, "s-d-h", 30, {{"cpu", 5},{"processing-unit", 10},{"multiply_module_1", 3}}, {{type="item", name="multiply_module_2", amount=1}},"crafting"),
recipe_nofluid_category("multiply_module_3", 0, "s-d-i", 30, {{"quad_circuit", 5},{"speed-module-3", 1},{"multiply_module_2", 1}}, {{type="item", name="multiply_module_3", amount=1}},"crafting"),

-- turret --
recipe_nofluid_category("siege_turret_1", 0, "s-e-a", 4, {{"gun-turret", 1},{"veridium", 15},{"copper-plate", 15},{"stone-brick", 20}}, {{type="item", name="siege_turret_1", amount=1}},"crafting"),
recipe_nofluid_category("siege_turret_2", 0, "s-e-b", 4, {{"siege_turret_1", 1},{"veridium_steel_plate", 10},{"plastic-bar", 15},{"stone-wall", 20}}, {{type="item", name="siege_turret_2", amount=1}},"crafting"),
recipe_nofluid_category("siege_turret_3", 0, "s-e-c", 4, {{"siege_turret_2", 1},{"veridium_steel_plate", 20},{"pure_veridium", 30},{"stone-wall", 40}}, {{type="item", name="siege_turret_3", amount=1}},"crafting"),

--- tech ---
recipe_nofluid_category("fmrx_lab", 0, "s-f-a", 1, {{"veridium", 15},{"electronic-circuit", 10},{"stone-brick", 10}}, {{type="item", name="fmrx_lab", amount=1}},"crafting"),
recipe_nofluid_category("t_resource_1", 0, "s-f-b", 8, {{"veridium_dust", 8},{"t_resource_1_form", 2},{"copper_ore_pack", 1}}, {{type="item", name="t_resource_1", amount=2}},"crafting"),
recipe_nofluid_category("t_resource_1_form", 0, "s-f-a", 1, {{"iron-plate", 1}}, {{type="item", name="t_resource_1_form", amount=1}},"crafting"),

--- weapon ---
recipe_nofluid_category("machine_gun", 0, "s-i-a", 0.5, {{"iron-plate", 8},{"veridium", 10}}, {{type="item", name="machine_gun", amount=1}}, "crafting"),
recipe_nofluid_category("machine_gun_cartridge_1", 0, "s-i-b", 7, {{"iron-plate", 10},{"gun_bullets", 16}}, {{type="item", name="machine_gun_cartridge_1", amount=2}}, "crafting"),
recipe_nofluid_category("turret_ammo_box", 0, "s-i-c", 6, {{"iron-plate", 8},{"gun_bullets", 12}}, {{type="item", name="turret_ammo_box", amount=2}}, "crafting"),
recipe_nofluid_category("shell_box", 0, "s-i-d", 2, {{"copper-plate", 6},{"veridium", 5}}, {{type="item", name="shell_box", amount=1}}, "crafting"),
recipe_nofluid_category("gun_bullets", 0, "s-i-i", 4, {{"veridium", 3}}, {{type="item", name="gun_bullets", amount=5}}, "crafting"),

--- weapon2 ---
recipe_nofluid_category("t55", 0, "s-j-a", 20, {{"veridium", 50},{"t55_wheel", 14},{"engine", 20},{"armor_plate_1", 80},{"round_circuit", 80}}, {{type="item", name="t55", amount=1}}, "crafting"),
recipe_nofluid_category("t55_shell", 0, "s-j-b", 4, {{"steel-plate", 2},{"veridium_steel_plate", 6},{"explosives", 2}}, {{type="item", name="t55_shell", amount=1}}, "crafting"),
recipe_nofluid_category("t55_explosive_shell", 0, "s-j-c", 4, {{"t55_shell", 1},{"veridium_steel_plate", 2},{"explosives", 10}}, {{type="item", name="t55_explosive_shell", amount=1}}, "crafting"),
recipe_nofluid_category("devastator", 0, "s-j-d", 20, {{"veridium", 50}, {"wheel", 12},{"engine", 24},{"armor_plate_2", 70},{"round_circuit", 120}}, {{type="item", name="devastator", amount=1}}, "crafting"),
recipe_nofluid_category("dev_shell_1", 0, "s-j-e", 4, {{"energy_saving_element", 20}, {"round_circuit", 4},{"veridium", 10}}, {{type="item", name="dev_shell_1", amount=1}}, "crafting"),
recipe_nofluid_category("dev_shell_2", 0, "s-j-f", 6, {{"dev_shell_1", 2},{"energy_saving_element", 30},{"pure_veridium", 10}}, {{type="item", name="dev_shell_2", amount=1}}, "crafting"),

--- equipment ---
recipe_nofluid_category("fuel_cell_1", 0, "s-k-a", 2, {{"electrolyte", 1},{"fc_frame", 1},{"energy_saving_element", 1}}, {{type="item", name="fuel_cell_1", amount=1}}, "crafting"),
recipe_nofluid_category("fuel_cell_2", 0, "s-k-b", 3, {{"electrolyte", 2},{"fuel_cell_1", 1}}, {{type="item", name="fuel_cell_2", amount=1}}, "crafting"),
recipe_nofluid_category("fuel_cell_3", 0, "s-k-c", 5, {{"electrolyte", 5},{"fuel_cell_2", 3}}, {{type="item", name="fuel_cell_3", amount=1}}, "crafting"),

recipe_nofluid_category("tank_battery_1", 0, "s-k-d", 10, {{"energy_saving_element", 50},{"round_circuit", 20},{"cpu", 5},{"pure_veridium", 20}}, {{type="item", name="tank_battery_1", amount=1}}, "crafting"),
recipe_nofluid_category("tank_battery_2", 0, "s-k-e", 10, {{"tank_battery_1", 3},{"energy_saving_element", 75},{"cpu", 20},{"pure_veridium", 50}}, {{type="item", name="tank_battery_2", amount=1}}, "crafting"),
recipe_nofluid_category("tank_battery_3", 0, "s-k-f", 10, {{"tank_battery_2", 3},{"energy_saving_element", 100},{"quad_circuit", 20},{"pure_veridium", 100}}, {{type="item", name="tank_battery_3", amount=1}}, "crafting"),

recipe_nofluid_category("energy_mg_1", 0, "s-k-fa", 10, {{"energy_saving_element", 20},{"round_circuit", 20},{"veridium_steel_plate", 10}}, {{type="item", name="energy_mg_1", amount=1}}, "crafting"),
recipe_nofluid_category("energy_mg_2", 0, "s-k-fb", 10, {{"energy_mg_1", 3},{"cpu", 20},{"pure_veridium", 50}}, {{type="item", name="energy_mg_2", amount=1}}, "crafting"),
recipe_nofluid_category("energy_mg_3", 0, "s-k-fc", 10, {{"energy_mg_2", 3},{"quad_circuit", 15},{"pure_veridium", 100}}, {{type="item", name="energy_mg_3", amount=1}}, "crafting"),

recipe_nofluid_category("energy_cannon_1", 0, "s-k-g", 10, {{"energy_saving_element", 20},{"round_circuit", 20},{"veridium_steel_plate", 10}}, {{type="item", name="energy_cannon_1", amount=1}}, "crafting"),
recipe_nofluid_category("energy_cannon_2", 0, "s-k-h", 10, {{"energy_cannon_1", 3},{"cpu", 20},{"pure_veridium", 50}}, {{type="item", name="energy_cannon_2", amount=1}}, "crafting"),
recipe_nofluid_category("energy_cannon_3", 0, "s-k-i", 10, {{"energy_cannon_2", 3},{"quad_circuit", 15},{"pure_veridium", 100}},{{type="item", name="energy_cannon_3", amount=1}}, "crafting"),

recipe_nofluid_category("tank_shield_1", 0, "s-k-j", 10, {{"energy_saving_element", 30},{"round_circuit", 20},{"veridium", 20}}, {{type="item", name="tank_shield_1", amount=1}}, "crafting"),
recipe_nofluid_category("tank_shield_2", 0, "s-k-k", 10, {{"tank_shield_1", 3},{"energy_saving_element", 100},{"cpu", 15},{"pure_veridium", 40}}, {{type="item", name="tank_shield_2", amount=1}}, "crafting"),
recipe_nofluid_category("tank_shield_3", 0, "s-k-l", 10, {{"tank_shield_2", 3},{"energy_saving_element", 200},{"quad_circuit", 15},{"pure_veridium", 100}}, {{type="item", name="tank_shield_3", amount=1}}, "crafting"),


})