 data:extend({
 
 {
    type = "ammo",
    name = "machine_gun_cartridge_1",
    icon = "__FMRx__/graphics/weapon/machine_gun_cartridge_1.png",
	icon_size = 32,
    flags = {"goes-to-main-inventory"},
    ammo_type =
    {
      category = "a_gun",
      action =
      {
        {
          type = "direct",
          action_delivery =
          {
            {
              type = "instant",
              source_effects =
              {
                {
                  type = "create-explosion",
                  entity_name = "explosion-gunshot"
                }
              },
              target_effects =
              {
                {
                  type = "create-entity",
                  entity_name = "explosion-hit"
                },
                {
                  type = "damage",
                  damage = { amount = 11 , type = "physical"}
                }
              }
            }
          }
        }
      }
    },
    magazine_size = 15,
    subgroup = "a_weapon",
    order = "b",
    stack_size = 100
  }, 
 
 {
    type = "ammo",
    name = "turret_ammo_box",
    icon = "__FMRx__/graphics/weapon/turret_ammo_box.png",
	icon_size = 32,
    flags = {"goes-to-main-inventory"},
    ammo_type =
    {
      category = "a_siege_turret",
      action =
      {
        {
          type = "direct",
          action_delivery =
          {
            {
              type = "instant",
              source_effects =
              {
                {
                  type = "create-explosion",
                  entity_name = "explosion-gunshot"
                }
              },
              target_effects =
              {
                {
                  type = "create-entity",
                  entity_name = "explosion-hit"
                },
                {
                  type = "damage",
                  damage = { amount = 14 , type = "physical"}
                }
              }
            }
          }
        }
      }
    },
    magazine_size = 15,
    subgroup = "a_weapon",
    order = "c",
    stack_size = 100
  },
  {
    type = "ammo",
    name = "shell_box",
    icon = "__FMRx__/graphics/weapon/shell_box.png",
	icon_size = 32,
    flags = {"goes-to-main-inventory"},
    ammo_type =
    {
      category = "shotgun-shell",
      target_type = "direction",
      action =
      {
        {
          type = "direct",
          action_delivery =
          {
            type = "instant",
            source_effects =
            {
              {
                type = "create-explosion",
                entity_name = "explosion-gunshot"
              }
            }
          }
        },
        {
          type = "direct",
          repeat_count = 16,
          action_delivery =
          {
            type = "projectile",
            projectile = "shell_box_projectile",
            starting_speed = 1,
            direction_deviation = 0.3,
            range_deviation = 0.3,
            max_range = 15
          }
        }
      }
    },
    magazine_size = 10,
    subgroup = "a_weapon",
    order = "d",
    stack_size = 200
  }, 

--- T 55 --- 
  {
    type = "ammo",
    name = "t55_shell",
    icon = "__FMRx__/graphics/weapon/t55_shell.png",
	icon_size = 32,
    flags = {"goes-to-main-inventory"},
    ammo_type =
    {
      category = "t55_ammo",
      target_type = "direction",
      action =
      {
        type = "direct",
        action_delivery =
        {
          type = "projectile",
          projectile = "t55_projectile",
          starting_speed = 1,
          direction_deviation = 0,
          range_deviation = 0,
          max_range = 30,
          source_effects =
          {
            type = "create-explosion",
            entity_name = "explosion-gunshot"
          },
        }
      },
    },
    subgroup = "a_weapon2",
    order = "b",
    stack_size = 100
  },
  {
    type = "ammo",
    name = "t55_explosive_shell",
    icon = "__FMRx__/graphics/weapon/t55_explosive_shell.png",
	icon_size = 32,
    flags = {"goes-to-main-inventory"},
    ammo_type =
    {
      category = "t55_ammo",
      target_type = "direction",
      action =
      {
        type = "direct",
        action_delivery =
        {
          type = "projectile",
          projectile = "t55_explosive_projectile",
          starting_speed = 1,
          direction_deviation = 0,
          range_deviation = 0,
          max_range = 35,
          source_effects =
          {
            type = "create-explosion",
            entity_name = "explosion-gunshot"
          },
        }
      },
    },
    subgroup = "a_weapon2",
    order = "c",
    stack_size = 100
  },  
  
--- DEVASTATOR ---  
 {
    type = "ammo",
    name = "dev_shell_1",
    icon = "__FMRx__/graphics/weapon/dev_shell_1.png",
	icon_size = 32,
    flags = {"goes-to-main-inventory"},
    ammo_type =
    {
      category = "dev_ammo",
      target_type = "direction",
      action =
      {
        {
          type = "direct",
          action_delivery = 
          {
            type = "instant",
            source_effects = 
            {
              {
                type = "create-explosion",
                entity_name = "explosion-gunshot"
              }
            }
          }
        },
        {
          type = "direct",
          repeat_count = 3,
          action_delivery =
          {
            type = "projectile",
            projectile = "dev-pellet_1",
            starting_speed = 0.35,
            direction_deviation = 0.3,
            range_deviation = 0,
            max_range = 40
          }
        }
      }
    },
    magazine_size = 25,
    subgroup = "a_weapon2",
    order = "e",
    stack_size = 100
  }, 
  {
    type = "ammo",
    name = "dev_shell_2",
    icon = "__FMRx__/graphics/weapon/dev_shell_2.png",
	icon_size = 32,
    flags = {"goes-to-main-inventory"},
    ammo_type =
    {
      category = "dev_ammo",
      target_type = "direction",
      action =
      {
        {
          type = "direct",
          action_delivery = 
          {
            type = "instant",
            source_effects = 
            {
              {
                type = "create-explosion",
                entity_name = "explosion-gunshot"
              }
            }
          }
        },
        {
          type = "direct",
          repeat_count = 3,
          action_delivery =
          {
            type = "projectile",
            projectile = "dev-pellet_2",
            starting_speed = 0.35,
            direction_deviation = 0.3,
            range_deviation = 0,
            max_range = 40
          }
        }
      }
    },
    magazine_size = 25,
    subgroup = "a_weapon2",
    order = "f",
    stack_size = 100
  }, 
})