function fmrx_productivitymodulelimitation()
return 
      {
        "sulfuric-acid",
        "basic-oil-processing",
        "advanced-oil-processing",
        "coal-liquefaction",
        "heavy-oil-cracking",
        "light-oil-cracking",
        "solid-fuel-from-light-oil",
        "solid-fuel-from-heavy-oil",
        "solid-fuel-from-petroleum-gas",
        "lubricant",
        "wood",
        "iron-plate",
        "copper-plate",
        "steel-plate",
        "stone-brick",
        "sulfur",
        "plastic-bar",
        "empty-barrel",
        "uranium-processing",
        "copper-cable",
        "iron-stick",
        "iron-gear-wheel",
        "electronic-circuit",
        "advanced-circuit",
        "processing-unit",
        "engine-unit",
        "electric-engine-unit",
        "uranium-fuel-cell",
        "explosives",
        "battery",
        "flying-robot-frame",
        "low-density-structure",
        "rocket-fuel",
        "rocket-control-unit",
        "rocket-part",
        "science-pack-1",
        "science-pack-2",
        "science-pack-3",
        "military-science-pack",
        "production-science-pack",
        "high-tech-science-pack",
		"fuel_cell_1",
		"fuel_cell_2",
		"fuel_cell_3",
		"round_circuit",
		"cpu",
		"quad_circuit",
		"t_resource_1"
      }
end


data:extend({

--- Module 1 ---
  {
    type = "module",
    name = "rush_module_1",
    icon = "__FMRx__/graphics/module/M21.png",
	icon_size = 32,
    flags = {"goes-to-main-inventory"},
    subgroup = "a_module",
    category = "speed",
    tier = 1,
    order = "a",
    stack_size = 50,
    default_request_amount = 10,
    effect = { speed = {bonus = 0.3}, consumption = {bonus = 0.15}}
  },
  {
    type = "module",
    name = "rush_module_2",
    icon = "__FMRx__/graphics/module/M22.png",
	icon_size = 32,
    flags = {"goes-to-main-inventory"},
    subgroup = "a_module",
    category = "speed",
    tier = 2,
    order = "b",
    stack_size = 50,
    default_request_amount = 10,
    effect = { speed = {bonus = 0.6}, consumption = {bonus = 0.3}}
  },
  {
    type = "module",
    name = "rush_module_3",
    icon = "__FMRx__/graphics/module/M23.png",
	icon_size = 32,
    flags = {"goes-to-main-inventory"},
    subgroup = "a_module",
    category = "speed",
    tier = 3,
    order = "c",
    stack_size = 50,
    default_request_amount = 10,
    effect = { speed = {bonus = 0.8}, consumption = {bonus = 0.45}}
  },  
  
 --- Module 2 --- 
    {
    type = "module",
    name = "economy_module_1",
    icon = "__FMRx__/graphics/module/M11.png",
	icon_size = 32,
    flags = {"goes-to-main-inventory"},
    subgroup = "a_module",
    category = "effectivity",
    tier = 1,
    order = "d",
    stack_size = 50,
    default_request_amount = 10,
    effect = { consumption = {bonus = -0.35},speed = {bonus = 0.1}},
    limitation = production
  },
  {
    type = "module",
    name = "economy_module_2",
    icon = "__FMRx__/graphics/module/M12.png",
	icon_size = 32,
    flags = {"goes-to-main-inventory"},
    subgroup = "a_module",
    category = "effectivity",
    tier = 2,
    order = "e",
    stack_size = 50,
    default_request_amount = 10,
    effect = { consumption = {bonus = -0.50},speed = {bonus = 0.2}},
    limitation = production
  },
  {
    type = "module",
    name = "economy_module_3",
    icon = "__FMRx__/graphics/module/M13.png",
	icon_size = 32,
    flags = {"goes-to-main-inventory"},
    subgroup = "a_module",
    category = "effectivity",
    tier = 3,
    order = "f",
    stack_size = 50,
    default_request_amount = 10,
    effect = { consumption = {bonus = -0.65},speed = {bonus = 0.3}},
    limitation = production
  },

--- Module 3 ---  
  {
    type = "module",
    name = "multiply_module_1",
    icon = "__FMRx__/graphics/module/M31.png",
	icon_size = 32,
    flags = {"goes-to-main-inventory"},
    subgroup = "a_module",
    category = "productivity",
    tier = 1,
    order = "g",
    stack_size = 50,
    default_request_amount = 10,
    effect = 
    {
      productivity = {bonus = 0.07},
      consumption = {bonus = 0.25},
      speed = {bonus = -0.10}
    },
    limitation = fmrx_productivitymodulelimitation(),
    limitation_message_key = "production-module-usable-only-on-intermediates"
  },
  {
    type = "module",
    name = "multiply_module_2",
    icon = "__FMRx__/graphics/module/M32.png",
	icon_size = 32,
    flags = {"goes-to-main-inventory"},
    subgroup = "a_module",
    category = "productivity",
    tier = 2,
    order = "h",
    stack_size = 50,
    default_request_amount = 10,
    effect = 
    {
      productivity = {bonus = 0.15},
      consumption = {bonus = 0.5},
      speed = {bonus = -0.05}
    },
    limitation = fmrx_productivitymodulelimitation(),
    limitation_message_key = "production-module-usable-only-on-intermediates"
  },  
  {
    type = "module",
    name = "multiply_module_3",
    icon = "__FMRx__/graphics/module/M33.png",
	icon_size = 32,
    flags = {"goes-to-main-inventory"},
    subgroup = "a_module",
    category = "productivity",
    tier = 3,
    order = "i",
    stack_size = 50,
    default_request_amount = 10,
    effect = 
    {
      productivity = {bonus = 0.22},
      consumption = {bonus = 0.75}
    },
    limitation = fmrx_productivitymodulelimitation(),
    limitation_message_key = "production-module-usable-only-on-intermediates"
  },

  {
    type = "projectile",
    name = "shell_box_projectile",
    flags = {"not-on-map"},
    collision_box = {{-0.05, -0.25}, {0.05, 0.25}},
    acceleration = 0,
    direction_only = true,
    action =
    {
      type = "direct",
      action_delivery =
      {
        type = "instant",
        target_effects =
        {
          type = "damage",
          damage = {amount = 7, type = "physical"}
        }
      }
    },
    animation =
    {
      filename = "__base__/graphics/entity/bullet/bullet.png",
      frame_count = 1,
      width = 3,
      height = 50,
      priority = "high"
    }
  },
-- T55 --
{
    type = "projectile",
    name = "t55_projectile",
    flags = {"not-on-map"},
    collision_box = {{-0.15, -1.1}, {0.1, 1.1}},
    acceleration = 0,
    direction_only = true,
    piercing_damage = 300,
    action =
    {
      type = "direct",
      action_delivery =
      {
        type = "instant",
        target_effects =
        {
          {
            type = "damage",
            damage = { amount = 225 , type = "physical"}
          },
          {
            type = "damage",
            damage = { amount = 125 , type = "explosion"}
          }
        }
      }
    },
    final_action =
    {
      type = "direct",
      action_delivery =
      {
        type = "instant",
        target_effects =
        {
          {
            type = "create-entity",
            entity_name = "explosion",
            check_buildability = true
          }
        }
      }
    },
    animation =
    {
      filename = "__FMRx__/graphics/t55/cannon_projectile.png",
      frame_count = 1,
      width = 10,
      height = 50,
      priority = "high"
    },
  },
  {
    type = "projectile",
    name = "t55_explosive_projectile",
    flags = {"not-on-map"},
    collision_box = {{-0.15, -1.1}, {0.1, 1.1}},
    acceleration = 0,
    direction_only = true,
    piercing_damage = 150,
    action =
    {
      type = "direct",
      action_delivery =
      {
        type = "instant",
        target_effects =
        {
          {
            type = "damage",
            damage = { amount = 150, type = "physical"}
          }
        }
      }
    },
    final_action =
    {
      type = "direct",
      action_delivery =
      {
        type = "instant",
        target_effects =
        {
          {
            type = "create-entity",
            entity_name = "big-explosion",
            check_buildability = true
          },
          {
            type = "nested-result",
            action =
            {
              type = "area",
              radius = 6,
              action_delivery =
              {
                type = "instant",
                target_effects =
                {
                  {
                    type = "damage",
                    damage = {amount = 350, type = "explosion"}
                  },
                  {
                    type = "create-entity",
                    entity_name = "explosion"
                  }
                }
              }
            }
          }
        }
      }
    },
    animation =
    {
      filename = "__FMRx__/graphics/t55/cannon_projectile.png",
      frame_count = 1,
      width = 6,
      height = 50,
      priority = "high"
    },
  },
  
--- DEVASTATOR ---
 {
    type = "projectile",
    name = "dev-pellet_1",
    flags = {"not-on-map"},
    collision_box = {{-0.3, -0.3}, {0.3, 0.3}},
    acceleration = 0,
    direction_only = true,
    action =
    {
      type = "direct",
      action_delivery =
      {
        type = "instant",
        target_effects =
        {
          type = "damage",
          damage = {amount = 16, type = "laser"}
        }
      }
    },
    animation =
    {
      filename = "__FMRx__/graphics/devastator/dev_projectile_1.png",
      frame_count = 8,
      width = 20,
      height = 20,
      priority = "high"
    },
  },
  {
    type = "projectile",
    name = "dev-pellet_2",
    flags = {"not-on-map"},
    collision_box = {{-0.3, -0.3}, {0.3, 0.3}},
    acceleration = 0,
    direction_only = true,
    action =
    {
      type = "direct",
      action_delivery =
      {
        type = "instant",
        target_effects =
        {
          type = "damage",
          damage = {amount = 24, type = "laser"}
        }
      }
    },
    animation =
    {
      filename = "__FMRx__/graphics/devastator/dev_projectile_2.png",
      frame_count = 8,
      width = 20,
      height = 20,
      priority = "high"
    }
  }  
  
  
  
})