function gun_turret_attack(inputs)
return
{
      width = 128,
      height = 128,
      frame_count = inputs.frame_count and inputs.frame_count or 2,
      axially_symmetrical = false,
      direction_count = 64,
      shift = {0, -0.5},
      stripes =
      {
        {
          filename = "__FMRx__/graphics/siege_turret/siege_turret_1.png",
          width_in_frames = inputs.frame_count and inputs.frame_count or 2,
          height_in_frames = 16,
        },
        {
          filename = "__FMRx__/graphics/siege_turret/siege_turret_2.png",
          width_in_frames = inputs.frame_count and inputs.frame_count or 2,
          height_in_frames = 16,
        },
        {
          filename = "__FMRx__/graphics/siege_turret/siege_turret_3.png",
          width_in_frames = inputs.frame_count and inputs.frame_count or 2,
          height_in_frames = 16,
        },
        {
          filename = "__FMRx__/graphics/siege_turret/siege_turret_4.png",
          width_in_frames = inputs.frame_count and inputs.frame_count or 2,
          height_in_frames = 16,
        }		
      }

    
}
end 

function gun_turret_attack2(inputs)
return
{
      width = 128,
      height = 128,
      frame_count = inputs.frame_count and inputs.frame_count or 2,
      axially_symmetrical = false,
      direction_count = 64,
      shift = {0, -0.5},
      stripes =
      {
        {
          filename = "__FMRx__/graphics/siege_turret/siege_turret2_1.png",
          width_in_frames = inputs.frame_count and inputs.frame_count or 2,
          height_in_frames = 16,
        },
        {
          filename = "__FMRx__/graphics/siege_turret/siege_turret2_2.png",
          width_in_frames = inputs.frame_count and inputs.frame_count or 2,
          height_in_frames = 16,
        },
        {
          filename = "__FMRx__/graphics/siege_turret/siege_turret2_3.png",
          width_in_frames = inputs.frame_count and inputs.frame_count or 2,
          height_in_frames = 16,
        },
        {
          filename = "__FMRx__/graphics/siege_turret/siege_turret2_4.png",
          width_in_frames = inputs.frame_count and inputs.frame_count or 2,
          height_in_frames = 16,
        }		
      }

    
}
end 

function gun_turret_attack3(inputs)
return
{
      width = 128,
      height = 128,
      frame_count = inputs.frame_count and inputs.frame_count or 2,
      axially_symmetrical = false,
      direction_count = 64,
      shift = {0, -0.5},
      stripes =
      {
        {
          filename = "__FMRx__/graphics/siege_turret/siege_turret3_1.png",
          width_in_frames = inputs.frame_count and inputs.frame_count or 2,
          height_in_frames = 16,
        },
        {
          filename = "__FMRx__/graphics/siege_turret/siege_turret3_2.png",
          width_in_frames = inputs.frame_count and inputs.frame_count or 2,
          height_in_frames = 16,
        },
        {
          filename = "__FMRx__/graphics/siege_turret/siege_turret3_3.png",
          width_in_frames = inputs.frame_count and inputs.frame_count or 2,
          height_in_frames = 16,
        },
        {
          filename = "__FMRx__/graphics/siege_turret/siege_turret3_4.png",
          width_in_frames = inputs.frame_count and inputs.frame_count or 2,
          height_in_frames = 16,
        }		
      }

    
}
end 


data:extend({

-- ORE EXTRACTOR ---
  {
    type = "mining-drill",
    name = "ore_extractor_1",
    icon = "__FMRx__/graphics/ore_extractor/ore_extractor_1_ico.png",
	icon_size = 32,
    flags = {"placeable-neutral", "player-creation"},
    resource_categories = {"basic-solid"},
    minable = {mining_time = 1, result = "ore_extractor_1"},
    max_health = 300,
    corpse = "medium-remnants",
    collision_box = {{ -0.85, -0.85}, {0.85, 0.85}},
    selection_box = {{ -1, -1}, {1, 1}},
    mining_speed = 1,
    working_sound =
    {
      sound =
      {
        filename = "__base__/sound/burner-mining-drill.ogg",
        volume = 0.8
      },
    },
    energy_source =
    {
      type = "burner",
      fuel_category = "chemical",
      effectivity = 1,
      fuel_inventory_size = 1,
      emissions = 1 / 20,
      smoke = 
      {
        {
          name = "smoke",
          deviation = {0.1, 0.1},
          frequency = 3
        }
      }
    },
    energy_usage = "250kW",
    mining_power = 3,
    animations =
    {
      north =
      {
        priority = "extra-high",
        width = 64,
        height = 64,
        line_length = 6,
        shift = {0, 0},
        filename = "__FMRx__/graphics/ore_extractor/ore_extractor_1.png",
        frame_count = 24,
        animation_speed = 0.5,
        --run_mode = "forward-then-backward",
      },
      east =
      {
        priority = "extra-high",
        width = 64,
        height = 64,
        line_length = 6,
        shift = {0, 0},
        filename = "__FMRx__/graphics/ore_extractor/ore_extractor_1.png",
        frame_count = 24,
        animation_speed = 0.5,
        --run_mode = "forward-then-backward",
      },
      south =
      {
        priority = "extra-high",
        width = 64,
        height = 64,
        line_length = 6,
        shift = {0, 0},
        filename = "__FMRx__/graphics/ore_extractor/ore_extractor_1.png",
        frame_count = 24,
        animation_speed = 0.5,
        --run_mode = "forward-then-backward",
      },
      west =
      {
        priority = "extra-high",
        width = 64,
        height = 64,
        line_length = 6,
        shift = {0, 0},
        filename = "__FMRx__/graphics/ore_extractor/ore_extractor_1.png",
        frame_count = 24,
        animation_speed = 0.5,
        --run_mode = "forward-then-backward",
      },
    },
    resource_searching_radius = 2.49,
    vector_to_place_result = {0.5, -1.3},
	module_specification =
    {
      module_slots = 1
    },
	radius_visualisation_picture =
    {
      filename = "__base__/graphics/entity/electric-mining-drill/electric-mining-drill-radius-visualization.png",
      width = 12,
      height = 12
    },
    fast_replaceable_group = "mining-drill"
  },
  {
    type = "mining-drill",
    name = "ore_extractor_2",
    icon = "__FMRx__/graphics/ore_extractor/ore_extractor_2_ico.png",
	icon_size = 32,
    flags = {"placeable-neutral", "player-creation"},
    resource_categories = {"basic-solid"},
    minable = {mining_time = 1, result = "ore_extractor_2"},
    max_health = 100,
    corpse = "medium-remnants",
    collision_box = {{ -0.85, -0.85}, {0.85, 0.85}},
    selection_box = {{ -1, -1}, {1, 1}},
    mining_speed = 1.5,
    working_sound =
    {
      sound =
      {
        filename = "__base__/sound/burner-mining-drill.ogg",
        volume = 0.8
      },
    },
    energy_source =
    {
      type = "burner",
      fuel_category = "chemical",
      effectivity = 1,
      fuel_inventory_size = 1,
      emissions = 1 / 20,
      smoke = 
      {
        {
          name = "smoke",
          deviation = {0.1, 0.1},
          frequency = 3
        }
      }
    },
    energy_usage = "400kW",
    mining_power = 3,
    animations =
    {
      north =
      {
        priority = "extra-high",
        width = 64,
        height = 64,
        line_length = 6,
        shift = {0, 0},
        filename = "__FMRx__/graphics/ore_extractor/ore_extractor_2.png",
        frame_count = 24,
        animation_speed = 0.5,
        --run_mode = "forward-then-backward",
      },
      east =
      {
        priority = "extra-high",
        width = 64,
        height = 64,
        line_length = 6,
        shift = {0, 0},
        filename = "__FMRx__/graphics/ore_extractor/ore_extractor_2.png",
        frame_count = 24,
        animation_speed = 0.5,
        --run_mode = "forward-then-backward",
      },
      south =
      {
        priority = "extra-high",
        width = 64,
        height = 64,
        line_length = 6,
        shift = {0, 0},
        filename = "__FMRx__/graphics/ore_extractor/ore_extractor_2.png",
        frame_count = 24,
        animation_speed = 0.5,
        --run_mode = "forward-then-backward",
      },
      west =
      {
        priority = "extra-high",
        width = 64,
        height = 64,
        line_length = 6,
        shift = {0, 0},
        filename = "__FMRx__/graphics/ore_extractor/ore_extractor_2.png",
        frame_count = 24,
        animation_speed = 0.5,
        --run_mode = "forward-then-backward",
      },
    },
    resource_searching_radius = 2.99,
    vector_to_place_result = {0.5, -1.3},
	module_specification =
    {
      module_slots = 2
    },
	radius_visualisation_picture =
    {
      filename = "__base__/graphics/entity/electric-mining-drill/electric-mining-drill-radius-visualization.png",
      width = 12,
      height = 12
    },
    fast_replaceable_group = "mining-drill"
  },
  {
    type = "mining-drill",
    name = "ore_extractor_3",
    icon = "__FMRx__/graphics/ore_extractor/ore_extractor_3_ico.png",
	icon_size = 32,
    flags = {"placeable-neutral", "player-creation"},
    resource_categories = {"basic-solid"},
    minable = {mining_time = 1, result = "ore_extractor_3"},
    max_health = 100,
    corpse = "medium-remnants",
    collision_box = {{ -0.85, -0.85}, {0.85, 0.85}},
    selection_box = {{ -1, -1}, {1, 1}},
    mining_speed = 1.8,
    working_sound =
    {
      sound =
      {
        filename = "__base__/sound/burner-mining-drill.ogg",
        volume = 0.8
      },
    },
    energy_source =
    {
      type = "burner",
      fuel_category = "chemical",
      effectivity = 1,
      fuel_inventory_size = 1,
      emissions = 1 / 20,
      smoke = 
      {
        {
          name = "smoke",
          deviation = {0.1, 0.1},
          frequency = 3
        }
      }
    },
    energy_usage = "550kW",
    mining_power = 3.5,
    animations =
    {
      north =
      {
        priority = "extra-high",
        width = 64,
        height = 64,
        line_length = 6,
        shift = {0, 0},
        filename = "__FMRx__/graphics/ore_extractor/ore_extractor_3.png",
        frame_count = 24,
        animation_speed = 0.5,
        --run_mode = "forward-then-backward",
      },
      east =
      {
        priority = "extra-high",
        width = 64,
        height = 64,
        line_length = 6,
        shift = {0, 0},
        filename = "__FMRx__/graphics/ore_extractor/ore_extractor_3.png",
        frame_count = 24,
        animation_speed = 0.5,
        --run_mode = "forward-then-backward",
      },
      south =
      {
        priority = "extra-high",
        width = 64,
        height = 64,
        line_length = 6,
        shift = {0, 0},
        filename = "__FMRx__/graphics/ore_extractor/ore_extractor_3.png",
        frame_count = 24,
        animation_speed = 0.5,
        --run_mode = "forward-then-backward",
      },
      west =
      {
        priority = "extra-high",
        width = 64,
        height = 64,
        line_length = 6,
        shift = {0, 0},
        filename = "__FMRx__/graphics/ore_extractor/ore_extractor_3.png",
        frame_count = 24,
        animation_speed = 0.5,
        --run_mode = "forward-then-backward",
      },
    },
    resource_searching_radius = 3.49,
    vector_to_place_result = {0.5, -1.3},
	module_specification =
    {
      module_slots = 3
    },	
	radius_visualisation_picture =
    {
      filename = "__base__/graphics/entity/electric-mining-drill/electric-mining-drill-radius-visualization.png",
      width = 12,
      height = 12
    },
    fast_replaceable_group = "mining-drill"
  },

--- ELECTRIC ORE EXTRACTOR ---
{
    type = "mining-drill",
    name = "electric_ore_extractor_1",
    icon = "__FMRx__/graphics/ore_extractor/electric_ore_extractor_1_ico.png",
    icon_size = 32,
    flags = {"placeable-neutral", "player-creation"},
    minable = {mining_time = 1, result = "electric_ore_extractor_1"},
    max_health = 600,
    resource_categories = {"basic-solid"},
    corpse = "big-remnants",
    collision_box = {{ -2.35, -2.35}, {2.35, 2.35}},
    selection_box = {{ -2.5, -2.5}, {2.5, 2.5}},
    working_sound =
    {
      sound =
      {
        filename = "__base__/sound/electric-mining-drill.ogg",
        volume = 0.75
      },
      apparent_volume = 1.5,
    },
    vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },
    animations =
    {
      north =
      {
        priority = "extra-high",
        filename = "__FMRx__/graphics/ore_extractor/electric_ore_extractor_1.png",
        line_length = 8,
        width = 160,
        height = 160,
        frame_count = 48,
        animation_speed = 0.5,
        direction_count = 1,
        shift = {0, 0},
      },
      east =
      {
        priority = "extra-high",
        filename = "__FMRx__/graphics/ore_extractor/electric_ore_extractor_1.png",
        line_length = 8,
        width = 160,
        height = 160,
        frame_count = 48,
        animation_speed = 0.5,
        direction_count = 1,
        shift = {0, 0},
      },
      south =
      {
        priority = "extra-high",
        filename = "__FMRx__/graphics/ore_extractor/electric_ore_extractor_1.png",
        line_length = 8,
        width = 160,
        height = 160,
        frame_count = 48,
        animation_speed = 0.5,
        direction_count = 1,
        shift = {0, 0},
      },
      west =
      {
        priority = "extra-high",
        filename = "__FMRx__/graphics/ore_extractor/electric_ore_extractor_1.png",
        line_length = 8,
        width = 160,
        height = 160,
        frame_count = 48,
        animation_speed = 0.5,
        direction_count = 1,
        shift = {0, 0},
      },
    },

    mining_speed = 4,
    energy_source =
    {
      type = "electric",
      -- will produce this much * energy pollution units per tick
      emissions = 0.15 / 1.5,
      usage_priority = "secondary-input"
    },
    energy_usage = "800kW",
    mining_power = 3,
    resource_searching_radius = 3.99,
    vector_to_place_result = {0, -2.85},
    module_specification =
    {
      module_slots = 3
    },
    radius_visualisation_picture =
    {
      filename = "__base__/graphics/entity/electric-mining-drill/electric-mining-drill-radius-visualization.png",
      width = 12,
      height = 12
    },
    monitor_visualization_tint = {r=78, g=173, b=255},
  },
 --- ---
 {
    type = "mining-drill",
    name = "electric_ore_extractor_2",
    icon = "__FMRx__/graphics/ore_extractor/electric_ore_extractor_2_ico.png",
    icon_size = 32,
    flags = {"placeable-neutral", "player-creation"},
    minable = {mining_time = 1, result = "electric_ore_extractor_2"},
    max_health = 800,
    resource_categories = {"basic-solid"},
    corpse = "big-remnants",
    collision_box = {{ -2.35, -2.35}, {2.35, 2.35}},
    selection_box = {{ -2.5, -2.5}, {2.5, 2.5}},
    working_sound =
    {
      sound =
      {
        filename = "__base__/sound/electric-mining-drill.ogg",
        volume = 0.75
      },
      apparent_volume = 1.5,
    },
    vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },
    animations =
    {
      north =
      {
        priority = "extra-high",
        filename = "__FMRx__/graphics/ore_extractor/electric_ore_extractor_2.png",
        line_length = 8,
        width = 160,
        height = 160,
        frame_count = 48,
        animation_speed = 0.5,
        direction_count = 1,
        shift = {0, 0},
      },
      east =
      {
        priority = "extra-high",
        filename = "__FMRx__/graphics/ore_extractor/electric_ore_extractor_2.png",
        line_length = 8,
        width = 160,
        height = 160,
        frame_count = 48,
        animation_speed = 0.5,
        direction_count = 1,
        shift = {0, 0},
      },
      south =
      {
        priority = "extra-high",
        filename = "__FMRx__/graphics/ore_extractor/electric_ore_extractor_2.png",
        line_length = 8,
        width = 160,
        height = 160,
        frame_count = 48,
        animation_speed = 0.5,
        direction_count = 1,
        shift = {0, 0},
      },
      west =
      {
        priority = "extra-high",
        filename = "__FMRx__/graphics/ore_extractor/electric_ore_extractor_2.png",
        line_length = 8,
        width = 160,
        height = 160,
        frame_count = 48,
        animation_speed = 0.5,
        direction_count = 1,
        shift = {0, 0},
      },
    },

    mining_speed = 6,
    energy_source =
    {
      type = "electric",
      -- will produce this much * energy pollution units per tick
      emissions = 0.15 / 1.5,
      usage_priority = "secondary-input"
    },
    energy_usage = "1.6MW",
    mining_power = 4,
    resource_searching_radius = 4.99,
    vector_to_place_result = {0, -2.85},
    module_specification =
    {
      module_slots = 4
    },
    radius_visualisation_picture =
    {
      filename = "__base__/graphics/entity/electric-mining-drill/electric-mining-drill-radius-visualization.png",
      width = 12,
      height = 12
    },
    monitor_visualization_tint = {r=78, g=173, b=255},
  },
  
--- TRAIN CHEST ---
{
    type = "container",
    name = "train_chest_h",
    icon = "__FMRx__/graphics/chest/train_chest_h_ico.png",
    icon_size = 32,
    flags = {"placeable-neutral", "player-creation"},
    minable = {mining_time = 1, result = "train_chest_h"},
    max_health = 500,
    corpse = "small-remnants",
    open_sound = { filename = "__base__/sound/metallic-chest-open.ogg", volume=0.65 },
    close_sound = { filename = "__base__/sound/metallic-chest-close.ogg", volume = 0.7 },
    resistances =
    {
      {
        type = "fire",
        percent = 90
      },
      {
        type = "impact",
        percent = 60
      }
    },
    collision_box = {{-1.35, -0.35}, {1.35, 0.35}},
    selection_box = {{-1.5, -0.5}, {1.5, 0.5}},
    inventory_size = 96,
    vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },
    picture =
    {
      filename = "__FMRx__/graphics/chest/train_chest_h.png",
      priority = "extra-high",
      width = 128,
      height = 32,
      shift = {0.5, 0}
    }
  }, 

{
    type = "container",
    name = "train_chest_v",
    icon = "__FMRx__/graphics/chest/train_chest_v_ico.png",
    icon_size = 32,
    flags = {"placeable-neutral", "player-creation"},
    minable = {mining_time = 1, result = "train_chest_v"},
    max_health = 500,
    corpse = "small-remnants",
    open_sound = { filename = "__base__/sound/metallic-chest-open.ogg", volume=0.65 },
    close_sound = { filename = "__base__/sound/metallic-chest-close.ogg", volume = 0.7 },
    resistances =
    {
      {
        type = "fire",
        percent = 90
      },
      {
        type = "impact",
        percent = 60
      }
    },
    collision_box = {{-0.35, -1.35}, {0.35, 1.35}},
    selection_box = {{-0.5, -1.5}, {0.5, 1.5}},
    inventory_size = 96,
    vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },
    picture =
    {
      filename = "__FMRx__/graphics/chest/train_chest_v.png",
      priority = "extra-high",
      width = 64,
      height = 96,
      shift = {0.5, 0}
    }
  },   
  
  
  --- GRINDER ---
 {
    type = "assembling-machine",
    name = "grinder",
    icon = "__FMRx__/graphics/grinder/grinder_ico.png",
	icon_size = 32,
    flags = {"placeable-neutral", "placeable-player", "player-creation"},
    minable = {hardness = 0.2, mining_time = 0.5, result = "grinder"},
    max_health = 400,
    corpse = "big-remnants",
    dying_explosion = "medium-explosion",
    resistances =
    {
      {
        type = "fire",
        percent = 70
      }
    },
    collision_box = {{-0.7, -0.7}, {0.7, 0.7}},
    selection_box = {{-1, -1}, {1, 1}},
    --fast_replaceable_group = "assembling-machine",
    animation =
    {
      filename = "__FMRx__/graphics/grinder/grinder.png",
      priority="high",
      width = 96,
      height = 64,
      frame_count = 24,
      line_length = 12,
      shift = {0.5, 0}
    },
    crafting_categories = {"grinder"},
    crafting_speed = 1,
    energy_source =
    {
      type = "electric",
      usage_priority = "secondary-input",
      emissions = 0.02
    },
    energy_usage = "60kW",
    ingredient_count = 3,
	module_specification =
    {
      module_slots = 2
    },
    allowed_effects = {"consumption", "speed", "productivity", "pollution"},
    open_sound = { filename = "__base__/sound/machine-open.ogg", volume = 0.85 },
    close_sound = { filename = "__base__/sound/machine-close.ogg", volume = 0.75 },
    vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },
    working_sound =
    {
      sound = {
        {
          filename = "__base__/sound/assembling-machine-t1-1.ogg",
          volume = 0.8
        },
        {
          filename = "__base__/sound/assembling-machine-t1-2.ogg",
          volume = 0.8
        },
      },
      idle_sound = { filename = "__base__/sound/idle1.ogg", volume = 0.6 },
      apparent_volume = 1.5,
    }
  },  
--- SIEGE TURRET ---
{
    type = "ammo-turret",
    name = "siege_turret_1",
    icon = "__FMRx__/graphics/siege_turret/siege_turret_ico.png",
	icon_size = 32,
    flags = {"placeable-player", "player-creation"},
    minable = {mining_time = 0.5, result = "siege_turret_1"},
    max_health = 450,
    corpse = "medium-remnants",
    collision_box = {{-1.2, -1.2 }, {1.2, 1.2}},
    selection_box = {{-1.5, -1.5 }, {1.5, 1.5}},
    rotation_speed = 0.015,
    preparing_speed = 0.08,
    folding_speed = 0.08,
    dying_explosion = "medium-explosion",
    inventory_size = 1,
    automated_ammo_count = 10,
    attacking_speed = 0.5,
	resistances =
    {
      {
        type = "physical",
        decrease = 3,
        percent = 5
      },
      {
        type = "explosion",
        decrease = 15,
        percent = 30
      },
      {
        type = "acid",
        decrease = 5,
        percent = 5
      }
    },
    folded_animation = 
    {
		filename = "__FMRx__/graphics/siege_turret/siege_turret_ext.png",
		priority = "medium",
		width = 128,
		height = 128,
		direction_count = 4,
		frame_count = 1,
		line_length = 1,
		run_mode = "forward",
		shift = {0, -0.5},
		axially_symmetrical = false
    },
    preparing_animation = 
    {
		filename = "__FMRx__/graphics/siege_turret/siege_turret_ext.png",
		priority = "medium",
		width = 128,
		height = 128,
		direction_count = 4,
		frame_count = 1,
		line_length = 1,
		run_mode = "forward",
		shift = {0, -0.5},
		axially_symmetrical = false
    },
    prepared_animation = gun_turret_attack{frame_count=1},
    attacking_animation = gun_turret_attack{},
    folding_animation = 
    { 
		filename = "__FMRx__/graphics/siege_turret/siege_turret_ext.png",
		priority = "medium",
		width = 128,
		height = 128,
		direction_count = 4,
		frame_count = 1,
		line_length = 1,
		run_mode = "backward",
		shift = {0, -0.5},
		axially_symmetrical = false
    },
    vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },
    attack_parameters =
    {
      type = "projectile",
      ammo_category = "a_siege_turret",
      cooldown = 10,
      projectile_creation_distance = 1.8,
      projectile_center = {0, 0.2}, -- same as gun_turret_attack shift
      damage_modifier = 1,
      shell_particle =
      {
        name = "shell-particle",
        direction_deviation = 0.1,
        speed = 0.1,
        speed_deviation = 0.03,
        center = {0, 0},
        creation_distance = -1.925,
        starting_frame_speed = 0.2,
        starting_frame_speed_deviation = 0.1
      },
      range = 19,
      sound = make_heavy_gunshot_sounds(),
    },
	call_for_help_radius = 40
  },

{
    type = "ammo-turret",
    name = "siege_turret_2",
    icon = "__FMRx__/graphics/siege_turret/siege_turret2_ico.png",
	icon_size = 32,
    flags = {"placeable-player", "player-creation"},
    minable = {mining_time = 0.5, result = "siege_turret_2"},
    max_health = 500,
    corpse = "medium-remnants",
    collision_box = {{-1.2, -1.2 }, {1.2, 1.2}},
    selection_box = {{-1.5, -1.5 }, {1.5, 1.5}},
    rotation_speed = 0.015,
    preparing_speed = 0.08,
    folding_speed = 0.08,
    dying_explosion = "medium-explosion",
    inventory_size = 1,
    automated_ammo_count = 10,
    attacking_speed = 0.5,
	resistances =
    {
      {
        type = "physical",
        decrease = 5,
        percent = 10
      },
      {
        type = "explosion",
        decrease = 20,
        percent = 30
      },
      {
        type = "acid",
        decrease = 8,
        percent = 10
      }
    },
    folded_animation = 
    {
		filename = "__FMRx__/graphics/siege_turret/siege_turret2_ext.png",
		priority = "medium",
		width = 128,
		height = 128,
		direction_count = 4,
		frame_count = 1,
		line_length = 1,
		run_mode = "forward",
		shift = {0, -0.5},
		axially_symmetrical = false
    },
    preparing_animation = 
    {
		filename = "__FMRx__/graphics/siege_turret/siege_turret2_ext.png",
		priority = "medium",
		width = 128,
		height = 128,
		direction_count = 4,
		frame_count = 1,
		line_length = 1,
		run_mode = "forward",
		shift = {0, -0.5},
		axially_symmetrical = false
    },
    prepared_animation = gun_turret_attack2{frame_count=1},
    attacking_animation = gun_turret_attack2{},
    folding_animation = 
    { 
		filename = "__FMRx__/graphics/siege_turret/siege_turret2_ext.png",
		priority = "medium",
		width = 128,
		height = 128,
		direction_count = 4,
		frame_count = 1,
		line_length = 1,
		run_mode = "backward",
		shift = {0, -0.5},
		axially_symmetrical = false
    },
    vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },
    attack_parameters =
    {
      type = "projectile",
      ammo_category = "a_siege_turret",
      cooldown = 10,
      projectile_creation_distance = 1.8,
      projectile_center = {0, 0.2}, -- same as gun_turret_attack shift
      damage_modifier = 1.2,
      shell_particle =
      {
        name = "shell-particle",
        direction_deviation = 0.1,
        speed = 0.1,
        speed_deviation = 0.03,
        center = {0, 0},
        creation_distance = -1.925,
        starting_frame_speed = 0.2,
        starting_frame_speed_deviation = 0.1
      },
      range = 20,
      sound = make_heavy_gunshot_sounds(),
    },
	call_for_help_radius = 40
  },

{
    type = "ammo-turret",
    name = "siege_turret_3",
    icon = "__FMRx__/graphics/siege_turret/siege_turret3_ico.png",
	icon_size = 32,
    flags = {"placeable-player", "player-creation"},
    minable = {mining_time = 0.5, result = "siege_turret_3"},
    max_health = 600,
    corpse = "medium-remnants",
    collision_box = {{-1.2, -1.2 }, {1.2, 1.2}},
    selection_box = {{-1.5, -1.5 }, {1.5, 1.5}},	
   --  collision_box = {{-0.7, -0.7 }, {0.7, 0.7}},
   --  selection_box = {{-1, -1 }, {1, 1}},
    rotation_speed = 0.015,
    preparing_speed = 0.08,
    folding_speed = 0.08,
    dying_explosion = "medium-explosion",
    inventory_size = 1,
    automated_ammo_count = 10,
    attacking_speed = 0.5,
	resistances =
    {
      {
        type = "physical",
        decrease = 7,
        percent = 10
      },
      {
        type = "explosion",
        decrease = 25,
        percent = 30
      },
      {
        type = "acid",
        decrease = 15,
        percent = 10
      }
    },
    folded_animation = 
    {
		filename = "__FMRx__/graphics/siege_turret/siege_turret3_ext.png",
		priority = "medium",
		width = 128,
		height = 128,
		direction_count = 4,
		frame_count = 1,
		line_length = 1,
		run_mode = "forward",
		shift = {0, -0.5},
		axially_symmetrical = false
    },
    preparing_animation = 
    {
		filename = "__FMRx__/graphics/siege_turret/siege_turret3_ext.png",
		priority = "medium",
		width = 128,
		height = 128,
		direction_count = 4,
		frame_count = 1,
		line_length = 1,
		run_mode = "forward",
		shift = {0, -0.5},
		axially_symmetrical = false
    },
    prepared_animation = gun_turret_attack3{frame_count=1},
    attacking_animation = gun_turret_attack3{},
    folding_animation = 
    { 
		filename = "__FMRx__/graphics/siege_turret/siege_turret3_ext.png",
		priority = "medium",
		width = 128,
		height = 128,
		direction_count = 4,
		frame_count = 1,
		line_length = 1,
		run_mode = "backward",
		shift = {0, -0.5},
		axially_symmetrical = false
    },
    vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },
    attack_parameters =
    {
      type = "projectile",
      ammo_category = "a_siege_turret",
      cooldown = 10,
      projectile_creation_distance = 1.8,
      projectile_center = {0, 0.2}, -- same as gun_turret_attack shift
      damage_modifier = 1.4,
      shell_particle =
      {
        name = "shell-particle",
        direction_deviation = 0.1,
        speed = 0.1,
        speed_deviation = 0.03,
        center = {0, 0},
        creation_distance = -1.925,
        starting_frame_speed = 0.2,
        starting_frame_speed_deviation = 0.1
      },
      range = 21,
      sound = make_heavy_gunshot_sounds(),
    },
	call_for_help_radius = 40
  },
--- TECH LAB ---
{
    type = "lab",
    name = "fmrx_lab",
    icon = "__FMRx__/graphics/lab/fmrx_lab_ico.png",
	icon_size = 32,
    flags = {"placeable-player", "player-creation"},
    minable = {mining_time = 1, result = "fmrx_lab"},
    max_health = 300,
    corpse = "big-remnants",
    dying_explosion = "medium-explosion",
    collision_box = {{-1.7, -1.2}, {1.7, 1.2}},
    selection_box = {{-2, -1.5}, {2, 1.5}},
    light = {intensity = 0.75, size = 8},
    on_animation =
    {
	  filename = "__FMRx__/graphics/lab/fmrx_lab_work.png",
      --priority="high",
      width = 128,
      height = 96,
      frame_count = 8,
      line_length = 2,
	  animation_speed = 0.1,
      shift = {0, 0}	
    },
    off_animation =
    {
      filename = "__FMRx__/graphics/lab/fmrx_lab_idle.png",
      width = 128,
      height = 96,
      frame_count = 1,
      shift = {0, 0}
    },
    working_sound =
    {
      sound =
      {
        filename = "__base__/sound/lab.ogg",
        volume = 0.7
      },
      apparent_volume = 1
    },
    energy_source =
    {
      type = "electric",
      usage_priority = "secondary-input"
    },
    energy_usage = "90kW",
    inputs =
    {
		"t_resource_1",
      --"science-pack-1",
      --"science-pack-2",
      --"science-pack-3",
      --"alien-science-pack"
    },
    module_specification =
    {
      module_slots = 2,
      max_entity_info_module_icons_per_row = 3,
      max_entity_info_module_icon_rows = 1,
      module_info_icon_shift = {0, 0.9}
    }
  },
  
   
  })